import os
import sys
import string
import commands
from sys import argv
import Pmw
import Tkinter
from Tkinter import *
import tkMessageBox

try:
	import chimera
	from chimera.baseDialog import ModelessDialog
	import VolumeViewer
except:
	print "Chimera not found"
	ModelessDialog=Tkinter.Window


class ssc(ModelessDialog):
	name = "ssc ui"
	buttons = ("Apply","Close")
	title = "Secondary Structure Element Hunter"
	direman=os.environ["HOME"]
	hellp = "%s/EMAN/doc/hh3c_help.html"%(direman)
	help = hellp

	def volume_data_set(self, model):
                d = VolumeViewer.volume_dialog()
                if d == None:
                        return None
                for dr in d.data_regions:
                        if model in dr.models():
                                return dr.data_set
                return None

	def targetSelector(self):
		##generate list of open volume files
		self.targets=[]
		self.targets=map(lambda x:x.name,chimera.openModels.list())
		self.targetButton.setitems(self.targets)

	def hhSelector(self):
		##generate list of open volume files
		self.hhselector=[]
		self.hhpath=[]
		self.hhnames=[]
                self.hhselector=filter(lambda x:str(x.__class__)=="VolumeViewer.surface.Surface_Model",chimera.openModels.list())
                for volume in self.hhselector:
                        self.hhnames.append(volume.name)
                        self.hhpath.append(self.volume_data_set(volume).data.path)
		self.hhnames.insert(0,"None")           
		self.intButton.setitems(self.hhnames)
				
	def fillInUI(self, parent):
		##setup frames for inputs
		self.frame0=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame0.grid(column=0,row=0, sticky=EW)
		self.frame12=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame12.grid(column=0,row=1, sticky=EW)
		self.frame1=Tkinter.Frame(self.frame12, bd=2, relief=FLAT)
		self.frame1.grid(column=0,row=0, sticky=EW)
		self.frame3=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame3.grid(column=0,row=2, sticky=EW)		
		self.frame4=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame4.grid(column=0,row=3, sticky=EW)	
		
		##Target Selection
		Label(self.frame0, text='target file:').grid(row=0, column=0, sticky=W)
		self.target=StringVar()
		self.targetButton=Pmw.OptionMenu(self.frame0,labelpos=W, menubutton_textvariable=self.target)
		self.targetButton.grid(row=0, column=1, sticky=W)
		self.targetSelector()
		Label(self.frame0, text='coefficient file:').grid(row=1, column=0, sticky=W)
		self.intfile=StringVar()
		self.intButton=Pmw.OptionMenu(self.frame0,labelpos=W, menubutton_textvariable=self.intfile)
		self.intButton.grid(row=1, column=1, sticky=W)
		self.hhSelector()
		coeff=StringVar()
		Label(self.frame0, text='correlation value:').grid(row=1, column=2, sticky=W)
		self.coeff = Entry(self.frame0, width = 6, textvariable=coeff)
		self.coeff.grid(row=1, column=3, sticky=W)
		coeff.set("0.3")
				
		##Required parameters
		Label(self.frame1, text='Required Parameters').grid(row=0, column=0, sticky=W)
		apix=StringVar()
		Label(self.frame1, text='angstrom/pixel:').grid(row=1, column=0, sticky=W)
		self.apix = Entry(self.frame1, width = 6, textvariable=apix)
		self.apix.grid(row=1, column=1, sticky=W)
		apix.set("1")
		res=StringVar()
		Label(self.frame1, text='resolution:').grid(row=2, column=0, sticky=W)
		self.res = Entry(self.frame1, width = 6, textvariable=res)
		self.res.grid(row=2, column=1, sticky=W)
		res.set("6")
		thr=StringVar()
		Label(self.frame1, text='threshold:').grid(row=3, column=0, sticky=W)
		self.thr = Entry(self.frame1, width = 6, textvariable=thr)
		self.thr.grid(row=3, column=1, sticky=W)
		thr.set("1")
		
		##optional parameters
		Label(self.frame3, text='Advanced Parameters').grid(row=0, column=0, sticky=W)
		
		Hangle=StringVar()
		Label(self.frame3, text='helix angle:').grid(row=1, column=0, sticky=W)
		self.Hangle = Entry(self.frame3, width = 6, textvariable=Hangle)
		self.Hangle.grid(row=1, column=1, sticky=W)
		Hangle.set("75")
		Hdist=StringVar()
		Label(self.frame3, text='helix distance:').grid(row=2, column=0, sticky=W)
		self.Hdist = Entry(self.frame3, width = 6, textvariable=Hdist)
		self.Hdist.grid(row=2, column=1, sticky=W)
		Hdist.set("7.5")

		Bangle=StringVar()
		Label(self.frame3, text='sheet angle:').grid(row=1, column=2, sticky=W)
		self.Bangle = Entry(self.frame3, width = 6, textvariable=Bangle)
		self.Bangle.grid(row=1, column=3, sticky=W)
		Bangle.set("75")
		Bdist=StringVar()
		Label(self.frame3, text='sheet distance:').grid(row=2, column=2, sticky=W)
		self.Bdist = Entry(self.frame3, width = 6, textvariable=Bdist)
		self.Bdist.grid(row=2, column=3, sticky=W)
		Bdist.set("5.0")		

		##Filter parameters
		Label(self.frame4, text='Filter Results').grid(row=0, column=0, sticky=W)
		Label(self.frame4, text='filter by:').grid(row=1, column=0, sticky=W)
		self.filter=StringVar()
		self.filter.set('magic')
		options=['magic', 'sigma', 'angle', 'correlation', 'points']
		self.filterButton=Pmw.OptionMenu(self.frame4,labelpos=W, menubutton_textvariable=self.filter, items=options)
		self.filterButton.grid(row=1, column=1, sticky=W)
		
		filtervalue=StringVar()
		self.filterValue = Entry(self.frame4, width = 6, textvariable=filtervalue)
		self.filterValue.grid(row=1, column=2, sticky=W)
		filtervalue.set("4.0")
		
	def Apply(self):
		intarget=str(self.target.get())
		openfiles=chimera.openModels.list()
		for t in openfiles:
                        if t.name==intarget:
                                check=str(t.__class__)
                                if check=="VolumeViewer.surface.Surface_Model":
                                        target=self.volume_data_set(t).data.path
                                elif check=="chimera.Molecule":
                                        pdbinfo=t.openedAs
                                        target=pdbinfo[0]
		
		
		apix=float(self.apix.get())
		res=float(self.res.get())
		t=intarget.split('.')
		targetNAME=str(t[0])
		
		hhint=str(self.intfile.get())
		hhthr=float(self.coeff.get())
		if hhint!='None':
			for path in self.hhpath:
				name=path.split('\\')
				n=name[-1]
				name2=n.split('/')
				checkin=str(name2[-1])
				if checkin==hhint:
					hhinfile=path
			
		Hangle=float(self.Hangle.get())
		Hdist=float(self.Hdist.get())
		Bangle=float(self.Bangle.get())
		Bdist=float(self.Bdist.get())

		thr=float(self.thr.get())

		filtertype=str(self.filter.get())
		filtervalue=float(self.filterValue.get())

		logfile="log-%s-hd-%f-ha-%f-sd-%f-sa-%f.txt"%(targetNAME,Hdist,Hangle,Bdist,Bangle)

		if hhint=="None":
			cmd0="ssehunter.py %s %f thr=%f helixdist=%f helixangle=%f filtertype=%s filtervalue=%f sheetdist=%f sheetangle=%f > %s"%(target,apix,thr,Hdist,Hangle,filtertype,filtervalue,Bdist,Bangle,logfile)
		else:
			cmd0="ssehunter.py %s %f thr=%f helixdist=%f helixangle=%f filtertype=%s filtervalue=%f sheetdist=%f sheetangle=%f hh=%s hhthr=%f >%s"%(target,apix,thr,Hdist,Hangle,filtertype,filtervalue,Bdist,Bangle,hhinfile,hhthr,logfile)

		print cmd0
		print sys.path
		os.system(cmd0)

		hfile="helix-%s-%f-%f-%s-%f.pdb"%(targetNAME,Hangle,Hdist,filtertype,filtervalue)
		bfile="sheet-%f-%f.pdb"%(Bangle,Bdist)
		if os.system("move")==1:
			cmd1="move helix2.pdb %s"%(hfile)
		else:
			cmd1="mv helix2.pdb %s"%(hfile)
		
		
		os.system(cmd1)
		chimera.openModels.open(hfile)
		chimera.openModels.open(bfile)
#		chimera.openModels.open("maybe-helix.pdb")
#		chimera.openModels.open("not-so-good-helices.pdb")
		chimera.openModels.open("good.pdb")
		chimera.openModels.open("bad.pdb")
try:
	chimera.dialogs.register(ssc.name, ssc)
except: pass

dialog = None

def gui():
	"""This is a Chimera specfic function to support instantiation of the dialog"""
	global dialog
	if not dialog:
		dialog = ssc()
	dialog.enter()

def Refresh(self, *triggerArgs, **kw):
	if ('model list change' in triggerArgs[-1].reasons) :
		dialog.targetSelector()
		dialog.hhSelector()
triggerOpenModels = chimera.triggers.addHandler('OpenModels', Refresh, None)
